/*
 * Copyright 2014, ACKme Networks
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of ACKme Networks;
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior
 * written permission of ACKme Networks.
 */

#pragma once


namespace wiconnect
{

class FunctionPointer
{
public:
    /*************************************************************************************************/
    FunctionPointer& operator=( const FunctionPointer& other )
    {
        _object = other._object;
        _function = other._function;
        _membercaller = other._membercaller;
        memcpy(_member, other._member, sizeof(_member));
        return *this;
    }

    /*************************************************************************************************/
    bool isValid() const
    {
        return (_function != NULL) || (_object != NULL);
    }

    /*************************************************************************************************/
    void setInvalid()
    {
        _function = NULL;
        _object = NULL;
    }

protected:
    void *_object;
    void *_function;
    char _member[16];
    void *_membercaller;
};

}
