/*
 * Copyright 2014, ACKme Networks
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of ACKme Networks;
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior
 * written permission of ACKme Networks.
 */

#pragma once

#include "WiconnectTypes.h"


namespace wiconnect
{

class PeriodicTimer WICONNECT_PERIODIC_TIMER_BASE_CLASS
{
public:
    PeriodicTimer();

    template<typename T>
    void start(T* tptr, void (T::*mptr)(void), int timeoutMs);
    void stop(void);
    bool isRunning();
protected:
    bool running;
};


}
