/*
 * Copyright 2014, ACKme Networks
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of ACKme Networks;
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior
 * written permission of ACKme Networks.
 */

#pragma once




namespace wiconnect
{


class SocketIrqHandlerMap;

class PinIrqHandler WICONNECT_EXTERNAL_INTERRUPT_GPIO_BASE_CLASS
{
public:
    PinIrqHandler(Pin irqPin, const Callback &callback);
    virtual ~PinIrqHandler();

    void irqHandler();

protected:
    PinName irqPin;
    Callback callback;

    friend class SocketIrqHandlerMap;
};


typedef uint8_t PinIrqHandlerBuffer[sizeof(PinIrqHandler)];

}
