/*
 * Copyright 2014, ACKme Networks
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of ACKme Networks;
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior
 * written permission of ACKme Networks.
 */

#pragma once


namespace wiconnect
{

class TimeoutTimer
{
public:
    TimeoutTimer();

    void reset(void);

    uint32_t remainingMs(uint32_t timeoutMs);
    uint32_t readUs();

    bool timedOut(uint32_t timeoutMs);

protected:
    uint32_t _start;

};


}
